; score.lisp - how to different patterns score?

(require :asdf)
(asdf:load-system :statslite)   ; https://thrig.me/src/statslite.git

(defun pattern-onset-deltas (pattern)
  (let ((deltas) (len (array-dimension pattern 0)))
    (loop for i from 0 for n across pattern do
          (when (plusp n)
            (loop for j from (1+ i) do
                  (when (plusp (aref pattern (mod j len)))
                    (push (- j i) deltas)
                    (loop-finish)))))
    deltas))
(defun pattern-score-sdev (pattern)
  (let ((stats (statslite:statslite (pattern-onset-deltas pattern))))
    (statslite:statslite-sd stats)))

(defun score (pattern)
  (format t "~a ~a~&" pattern (pattern-score-sdev pattern)))

(score #16*1000100010001000)
(score #16*1001000100010000)
(score #16*1010001000100000)
(score #16*1100010001000000)
(score #16*1100100010000000)
(score #16*1101000100000000)
(score #16*1110001000000000)
(score #16*1110010000000000)
(score #16*1110100000000000)
(score #16*1111000000000000)